<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/List.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/List.py</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/List.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2006 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno"> 7</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Processor, Parameter</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line10"></a><span class="lineno">10</span>
<a id="line11"></a><span class="lineno">11</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Formatters/List/Formatter.html">Formatter</a>(Processor, ASG.Visitor):</span>
<a id="line12"></a><span class="lineno">12</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Generate a high-level list of the content of a syn file.</span></span>
<a id="line13"></a><span class="lineno">13</span><span class="line"><span class="py-string">    This formatter can lists source files (by name), as well as</span></span>
<a id="line14"></a><span class="lineno">14</span><span class="line"><span class="py-string">    declarations (by name, type) contained in a given scope.&quot;&quot;&quot;</span></span>
<a id="line15"></a><span class="lineno">15</span>
<a id="line16"></a><span class="lineno">16</span><span class="line">    show_files = Parameter(False, <span class="py-string">'list files'</span>)</span>
<a id="line17"></a><span class="lineno">17</span><span class="line">    show_scope = Parameter(None, <span class="py-string">'list declarations in the given scope'</span>)</span>
<a id="line18"></a><span class="lineno">18</span>
<a id="line19"></a><span class="lineno">19</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/List/Formatter.html#process">process</a>(self, ir, **kwds):</span>
<a id="line20"></a><span class="lineno">20</span>
<a id="line21"></a><span class="lineno">21</span><span class="line">        self.set_parameters(kwds)</span>
<a id="line22"></a><span class="lineno">22</span><span class="line">        self.ir = self.merge_input(ir)</span>
<a id="line23"></a><span class="lineno">23</span>
<a id="line24"></a><span class="lineno">24</span><span class="line">        <span class="py-keyword">if</span> self.show_files:</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">            <span class="py-keyword">for</span> f <span class="py-keyword">in</span> self.ir.files.values():</span>
<a id="line26"></a><span class="lineno">26</span><span class="line">                <span class="py-keyword">print</span> <span class="py-string">'%s (language=%s, primary=%d)'</span>%(f.name, f.annotations[<span class="py-string">'language'</span>],</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">                                                      f.annotations[<span class="py-string">'primary'</span>])</span>
<a id="line28"></a><span class="lineno">28</span>
<a id="line29"></a><span class="lineno">29</span><span class="line">        <span class="py-keyword">if</span> self.show_scope <span class="py-keyword">is</span> <span class="py-keyword">not</span> None:</span>
<a id="line30"></a><span class="lineno">30</span><span class="line">            <span class="py-keyword">if</span> <span class="py-string">'.'</span> <span class="py-keyword">in</span> self.show_scope:</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">                self.scope = tuple(self.show_scope.split(<span class="py-string">'.'</span>))</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">            <span class="py-keyword">elif</span> <span class="py-string">'::'</span> <span class="py-keyword">in</span> self.show_scope:</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">                self.scope = tuple(self.show_scope.split(<span class="py-string">'::'</span>))</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">                self.scope = (self.show_scope,)</span>
<a id="line36"></a><span class="lineno">36</span>
<a id="line37"></a><span class="lineno">37</span><span class="line">            <span class="py-keyword">for</span> d <span class="py-keyword">in</span> self.ir.asg.declarations:</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">                d.accept(self)</span>
<a id="line39"></a><span class="lineno">39</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">        <span class="py-keyword">return</span> self.ir</span>
<a id="line41"></a><span class="lineno">41</span>
<a id="line42"></a><span class="lineno">42</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/List/Formatter.html#visit_scope">visit_scope</a>(self, node):</span>
<a id="line44"></a><span class="lineno">44</span>
<a id="line45"></a><span class="lineno">45</span><span class="line">        <span class="py-keyword">if</span> self.scope == node.name:</span>
<a id="line46"></a><span class="lineno">46</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">            <span class="py-comment"># We found the right scope.</span></span>
<a id="line48"></a><span class="lineno">48</span><span class="line">            <span class="py-comment"># List all declarations directly contained in it.</span></span>
<a id="line49"></a><span class="lineno">49</span><span class="line">            declarations = node.declarations[:]</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">            declarations.sort(<span class="py-keyword">lambda</span> x, y : cmp(x.name, y.name))</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">            <span class="py-keyword">for</span> d <span class="py-keyword">in</span> declarations:</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">                <span class="py-keyword">if</span> isinstance(d, ASG.Builtin): <span class="py-keyword">continue</span></span>
<a id="line53"></a><span class="lineno">53</span><span class="line">                <span class="py-keyword">print</span> <span class="py-string">'%s : %s'</span>%(d.name[-1], d.type)</span>
<a id="line54"></a><span class="lineno">54</span><span class="line">        <span class="py-keyword">elif</span> (len(node.name) &lt; self.scope <span class="py-keyword">and</span></span>
<a id="line55"></a><span class="lineno">55</span><span class="line">              self.scope[0:len(node.name)] == node.name):</span>
<a id="line56"></a><span class="lineno">56</span>
<a id="line57"></a><span class="lineno">57</span><span class="line">            <span class="py-comment"># We found a parent scope.</span></span>
<a id="line58"></a><span class="lineno">58</span><span class="line">            <span class="py-comment"># Visit child scopes.</span></span>
<a id="line59"></a><span class="lineno">59</span><span class="line">            <span class="py-keyword">for</span> d <span class="py-keyword">in</span> node.declarations:</span>
<a id="line60"></a><span class="lineno">60</span><span class="line">                d.accept(self)</span>
<a id="line61"></a><span class="lineno">61</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:14 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
